/* Input */
DIRECTIONS = {
	"north":     {"keys": ["w"],      "speed": {"x":  0, "y": -4}},
	"northeast": {"keys": ["w", "d"], "speed": {"x":  2, "y": -2}},
	"east":      {"keys": ["d"],      "speed": {"x":  4, "y":  0}},
	"southeast": {"keys": ["s", "d"], "speed": {"x":  2, "y":  2}},
	"south":     {"keys": ["s"],      "speed": {"x":  0, "y":  4}},
	"southwest": {"keys": ["s", "a"], "speed": {"x": -2, "y":  2}},
	"west":      {"keys": ["a"],      "speed": {"x": -4, "y":  0}},
	"northwest": {"keys": ["w", "a"], "speed": {"x": -2, "y": -2}}
};
var KEYS = Array();
document.onkeydown = function(e) {
	if (KEYS.indexOf(e.key) < 0) {
		KEYS.push(e.key);
	}
	keen.changeDirection();
}
var next_frame_keyup = null;
document.onkeyup = function(e) {
	if (!next_frame_keyup) {
		next_frame_keyup = e.key;
	} else {
		KEYS.splice(KEYS.indexOf(e.key), 1); // 2020 guys
		KEYS.splice(KEYS.indexOf(next_frame_keyup), 1);
		next_frame_keyup = null;
		keen.changeDirection();
	}
}


/* Objects */
var keen = new player();

objects = map.foreground;
entities = [];
for (var i = 0; i < objects.length; i++) {
	var o = objects[i];
	if (o.blocks === false) {
		console.log(o);
		entities.push(new object(o.src, o.x, o.y, o.oncollision, o.onactivate, false, o.width, o.height, o.alt));
	} else {
		entities.push(new object(o.src, o.x, o.y, o.oncollision, o.onactivate));
	}
}

document.body.style.backgroundImage = "url(assets/"+map.background+")";
for (var h = 0; h < map.clip.right; h++) {
	entities.push(new object("blank.gif", 32*h, 32*map.clip.top));
	entities.push(new object("blank.gif", 32*h, 32*map.clip.bottom));
}
for (var v = 0; v < map.clip.bottom; v++) {
	entities.push(new object("blank.gif", 32*map.clip.left, 32*v));
	entities.push(new object("blank.gif", 32*map.clip.right, 32*v));
}


/* Main */
var message_box = document.getElementById("message_box");
function message(msg) {
	message_box.style.opacity = msg == "" ? 0 : 1;
	message_box.innerText = msg;
}
function loop() {
	if (next_frame_keyup) { // This is the dumbest shit but I don't care it feels good on the game
		KEYS.splice(KEYS.indexOf(next_frame_keyup), 1);
		next_frame_keyup = null;
		keen.changeDirection();
	}
	message("");
	var x = keen.direction.startsWith("idle_") ? 0 : DIRECTIONS[keen.direction].speed.x;
	var y = keen.direction.startsWith("idle_") ? 0 : DIRECTIONS[keen.direction].speed.y;
	for (var i = 0; i < entities.length; i++) {
		var collision = entities[i].collides(keen.x, keen.y, keen.element.offsetWidth, keen.element.offsetHeight, x, y);
		if(collision && entities[i].blocks) {
			x = collision.x;
			y = collision.y;
		} else if (collision) {
			message(entities[i].alt);
		}
	}
	keen.setRelativePosition(x, y);
}

setInterval(loop, 33);

document.onkeypress = function(e) {
	if (e.key == "Enter") {
		for (var i = 0; i < entities.length; i++) {
			if (entities[i].collides(keen.x, keen.y, keen.element.offsetWidth, keen.element.offsetHeight)) {
				entities[i].onactivate();
			}
		}
	}
}

