class object extends entity {

	constructor(sprite, x=0, y=0, oncollision = function(){}, onactivate = function(){}, blocks=true, w=null, h=null, alt=null) {
		super();
		super.setSprite(sprite);
		this.x = x;
		this.y = y;
		super.setPosition(x, y);
		this.blocks = blocks;
		this.alt = alt;

		this.element.style.width = w+"px";
		this.element.style.height = h+"px";

		this.oncollision = oncollision;
		this.onactivate = onactivate;
	}

	collides(x, y, w, h, sx = 0, sy = 0) {
		/*
			X-->B (h)
			v   |
			C---X
		   (v)
		*/

		var b = this.x+this.element.offsetWidth;
		var c = this.y+this.element.offsetHeight;

		var iy = y+BV_ISOMETRY;
		var ih = h-BV_ISOMETRY*2;

		if ( ( x+sx>this.x && x+sx<b ) || ( x+sx+w>this.x && x+sx+w<b ) ) {
			if ( (iy+sy>this.y && iy+sy<c) || (iy+sy+ih>this.y && iy+sy+ih<c) ) {
				this.oncollision();
				if (sx || sy) {
					var slide = {"x": sx, "y": sy};
					if (this.collides(x+sx, y, w, h)) {
						slide.x = 0;
					}
					if (this.collides(x, y+sy, w, h)) {
						slide.y = 0;
					}
					return slide;
				}
				return true;
			}
		}
		return false;
	}

}
